Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/CurveAnalysis.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/CurveAnalysis.cs	(revision 16137)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/CurveAnalysis.cs	(revision 16137)
@@ -0,0 +1,192 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Analysis.FitnessLandscape {
+  public static class CurveAnalysis<T> {
+    public static CurveAnalysisResult GetCharacteristics(List<List<Tuple<T, double>>> trajectories, Func<T, T, double> distFunc) {
+      trajectories = trajectories.Where(x => x.Count > 5).ToList();
+      if (trajectories.Count == 0) return new CurveAnalysisResult(0, 0, 0, new[] { 0.0, 0.0, 0.0 }, new[] { 0.0, 0.0, 0.0 }, new[] { 0.0, 0.0, 0.0 });
+
+      var symbols = GetSymbols(trajectories);
+      var f1 = trajectories.Select(path => ApproximateDerivative(path, distFunc).ToList()).ToList();
+      var f2 = f1.Select(d1 => ApproximateDerivative(d1, distFunc).ToList()).ToList();
+
+      var sharpness = f1.Average(x => x.Average(y => Math.Abs(y.Item2)));
+      var bumpiness = 0.0;
+      var flatness = 0.0;
+      var count = 0;
+      for (var p = 0; p < f2.Count; p++) {
+        if (f2[p].Count <= 2) continue;
+        count++;
+        var bump = 0;
+        var flat = 0;
+        for (var i = 0; i < f2[p].Count - 1; i++) {
+          if ((f2[p][i].Item2 > 0 && f2[p][i + 1].Item2 < 0) || (f2[p][i].Item2 < 0 && f2[p][i + 1].Item2 > 0)) {
+            bump++;
+          } else if (f2[p][i].Item2 == 0) {
+            flat++;
+          }
+        }
+        bumpiness += bump / (f2[p].Count - 1.0);
+        flatness += flat / (f2[p].Count - 1.0);
+      }
+      bumpiness /= count;
+      flatness /= count;
+      var per = new[] { 25, 50, 75 };
+      return new CurveAnalysisResult(sharpness, bumpiness, flatness,
+        per.Select(p => symbols.Downward.GetPercentileOrDefault(p, 0)).ToArray(),
+        per.Select(p => symbols.Neutral.GetPercentileOrDefault(p, 0)).ToArray(),
+        per.Select(p => symbols.Upward.GetPercentileOrDefault(p, 0)).ToArray());
+    }
+
+    private static Symbols GetSymbols(List<List<Tuple<T, double>>> trajectories) {
+      var sym = new Symbols();
+      foreach (var t in trajectories) {
+        var prev = t[0];
+        for (var i = 1; i < t.Count; i++) {
+          sym.Add(i / (double)t.Count, t[i].Item2, prev.Item2);
+          prev = t[i];
+        }
+      }
+      return sym;
+    }
+
+    private static IEnumerable<Tuple<T, double>> ApproximateDerivative(IEnumerable<Tuple<T, double>> data, Func<T, T, double> distFunc) {
+      Tuple<T, double> prev = null, prev2 = null;
+      foreach (var d in data) {
+        if (prev == null) {
+          prev = d;
+          continue;
+        }
+        if (prev2 == null) {
+          prev2 = prev;
+          prev = d;
+          continue;
+        }
+        var dist = distFunc(prev2.Item1, d.Item1);
+        yield return Tuple.Create(prev.Item1, (d.Item2 - prev2.Item2) / dist);
+        prev2 = prev;
+        prev = d;
+      }
+    }
+  }
+
+  public enum CurveAnalysisFeature { Sharpness, Bumpiness, Flatness,
+                                     DownQ1, DownQ2, DownQ3,
+                                     NeutQ1, NeutQ2, NeutQ3,
+                                     UpQ1, UpQ2, UpQ3 }
+
+  public class CurveAnalysisResult {
+    private Dictionary<CurveAnalysisFeature, double> results = new Dictionary<CurveAnalysisFeature, double>();
+
+    public double GetValue(CurveAnalysisFeature name) {
+      return results[name];
+    }
+
+    public static IEnumerable<CurveAnalysisFeature> AllFeatures {
+      get { return Enum.GetValues(typeof(CurveAnalysisFeature)).Cast<CurveAnalysisFeature>(); }
+    }
+
+    public double[] GetValues() {
+      return AllFeatures.Select(x => results[x]).ToArray();
+    }
+
+    public CurveAnalysisResult(double sharpness, double bumpiness, double flatness, double[] down, double[] neut, double[] up) {
+      foreach (var v in AllFeatures.Zip(new[] { sharpness, bumpiness, flatness }.Concat(down).Concat(neut).Concat(up), (n, v) => Tuple.Create(n, v))) {
+        results[v.Item1] = v.Item2;
+      }
+    }
+  }
+
+  public class Symbols {
+    public Statistics Downward { get; } = new Statistics();
+    public Statistics Neutral { get; } = new Statistics();
+    public Statistics Upward { get; } = new Statistics();
+
+    public void Add(double step, double fit, double prev) {
+      if (fit < prev) Downward.Add(step);
+      else if (fit > prev) Upward.Add(step);
+      else Neutral.Add(step);
+    }
+  }
+
+  public sealed class Statistics {
+    private List<double> values = new List<double>();
+
+    public int Count { get { return values.Count; } }
+
+    public double Min { get; private set; }
+    public double Max { get; private set; }
+    public double Total { get; private set; }
+    public double Mean { get; private set; }
+    public double StdDev { get { return Math.Sqrt(Variance); } }
+    public double Variance { get { return Count > 0 ? variance / Count : 0.0; } }
+    
+    private double variance;
+    private bool sorted = false;
+    
+    public double GetPercentileOrDefault(int p, double @default = default(double)) {
+      if (p < 0 || p > 100) throw new ArgumentOutOfRangeException(nameof(p), p, "Must be in range [0;100]");
+      SortIfNecessary();
+      if (Count == 0) return @default;
+      else if (Count == 1) return values[0];
+      if (p == 100) return values[Count - 1];
+
+      var x = p / 100.0 * (Count - 1);
+      var inte = (int)x;
+      var frac = x - inte;
+
+      return values[inte] + frac * (values[inte + 1] - values[inte]);
+    }
+
+    public void Add(double value) {
+      sorted = false;
+      values.Add(value);
+
+      if (Count == 1) {
+        Min = Max = Mean = Total = value;
+      } else {
+        if (value < Min) Min = value;
+        if (value > Max) Max = value;
+
+        Total += value;
+        var oldMean = Mean;
+        Mean = oldMean + (value - oldMean) / Count;
+        variance = variance + (value - oldMean) * (value - Mean);
+      }
+    }
+
+    public void AddRange(IEnumerable<double> values) {
+      foreach (var v in values) Add(v);
+    }
+
+    private void SortIfNecessary() {
+      if (!sorted) {
+        values.Sort();
+        sorted = true;
+      }
+    }
+  }
+}
Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/DoubleMatrixCharacteristics.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/DoubleMatrixCharacteristics.cs	(revision 16137)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/DoubleMatrixCharacteristics.cs	(revision 16137)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Data;
+using System;
+using System.Linq;
+
+namespace HeuristicLab.Analysis.FitnessLandscape {
+  public static class DoubleMatrixCharacteristics {
+    public static double CoeffVariation(DoubleMatrix m) {
+      var avg = m.Average();
+      var stdDev = m.StandardDeviation();
+      return stdDev / avg;
+    }
+
+    public static double Sparsity(DoubleMatrix m) {
+      return m.Count(x => x == 0) / (double)(m.Rows * m.Columns);
+    }
+
+    public static double Disparity(DoubleMatrix m) {
+      if (m.Rows != m.Columns) throw new ArgumentException("not a quadratic matrix", "m");
+      var n = m.Rows;
+      var avg = m.Sum() / n;
+      var disparity = 0.0;
+      for (var i = 0; i < n; i++) {
+        var tmp = 0.0;
+        for (var j = 0; j < n; j++) {
+          tmp += m[i, j];
+        }
+        disparity += (tmp - avg) * (tmp - avg);
+      }
+      return Math.Sqrt(disparity / n) / avg;
+    }
+
+    public static double Skewness(DoubleMatrix m) {
+      double mean = 0, variance = 0, skewness = 0, kurtosis = 0;
+      alglib.basestat.samplemoments(m.ToArray(), m.Rows * m.Columns, ref mean, ref variance, ref skewness, ref kurtosis);
+      return skewness;
+    }
+
+    public static double Asymmetry(DoubleMatrix m) {
+      if (m.Rows != m.Columns) throw new ArgumentException("not a quadratic matrix", "m");
+      var n = m.Rows;
+      var count = 0;
+      for (var i = 0; i < n; i++) {
+        for (var j = 0; j < i; j++) {
+          var v = Math.Abs(m[i, j] - m[j, i]);
+          if (v > 0) {
+            count++;
+          }
+        }
+      }
+      return count / (n * (n - 1) / 2.0);
+    }
+  }
+}
Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/UniqueThresholdCalculator.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/UniqueThresholdCalculator.cs	(revision 16137)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/Utilities/UniqueThresholdCalculator.cs	(revision 16137)
@@ -0,0 +1,179 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+
+namespace HeuristicLab.Analysis.FitnessLandscape {
+
+  public static class UniqueThresholdCalculator {
+
+    private sealed class IndexRange {
+
+      public int Start, End, N;
+      public readonly bool Merge;
+      private readonly List<IndexRange> receivers, distributors;
+
+      public IndexRange(int start, int end, int n, bool merge) {
+        Start = start;
+        End = end;
+        N = n;
+        Merge = merge;
+        receivers = new List<IndexRange>();
+        distributors = new List<IndexRange>();
+      }
+
+      public void AddReceiver(IndexRange receiver) {
+        if (receiver != null) {
+          receivers.Add(receiver);
+          receiver.distributors.Add(this);
+        }
+      }
+
+      public void Distribute() {
+        int n = N - 1;
+        Debug.Assert(n >= 0);
+        switch (receivers.Count) {
+          case 0: break; // No receivers indexes are lost :-(
+          case 1: receivers[0].N += n; N = 1; break;
+          case 2: receivers[0].N += n / 2; receivers[1].N += n - n / 2; N = 1; break;
+          default: throw new InvalidOperationException("More than two receivers registered");
+        }
+        var followers = distributors.Where(d => d.Start > End).ToList();
+        if (followers.Count > 0)
+          End = followers.Min(g => g.Start);
+        var predecessors = distributors.Where(d => d.End < Start).ToList();
+        if (predecessors.Count > 0)
+          Start = predecessors.Max(g => g.End);
+      }
+
+      public override string ToString() {
+        return string.Format("[{0}-{1}, n={2}, {3}]", Start, End, N, Merge ? "Merge" : "Spread");
+      }
+    }
+
+    public static IEnumerable<double> DetermineThresholds(IEnumerable<double> differences, int n) {
+      var thresholds = differences.Select(d => Math.Abs(d)).ToList();
+      thresholds.Sort();
+      if (thresholds.Count <= n) {
+        foreach (var t in thresholds)
+          yield return t;
+      } else {
+        double min = thresholds[0];
+        double max = thresholds[thresholds.Count - 1];
+        if (min == max) {
+          yield return min;
+        } else {
+          yield return min;
+          foreach (var t in DetermineInnerThresholds(thresholds, n - 2))
+            yield return t;
+          yield return max;
+        }
+      }
+    }
+
+    private static IEnumerable<double> DetermineInnerThresholds(List<double> thresholds, int n) {
+      n = Math.Min(thresholds.Count - 2, n);
+      var indexes = Enumerable.Range(0, n + 2).Select(i => (int)Math.Round(1.0 * i * (thresholds.Count - 1) / (n + 1))).ToList();
+      var ranges = CreateRanges(thresholds, indexes);
+      RedistributeIndexes(ranges);
+      TrimBoundaryRanges(ranges);
+      if (ranges.Count == 1 && ranges[0].Start == 0 && ranges[0].End == thresholds.Count - 1 && ranges[0].N == n) {
+        if (ranges[0].Merge)
+          yield return thresholds[ranges[0].Start];
+        else
+          foreach (var i in indexes.Where(i => ranges[0].Start < i && i < ranges[0].End))
+            yield return thresholds[i];
+      } else {
+        foreach (var range in ranges) {
+          if (range.Merge)
+            yield return thresholds[range.Start];
+          else
+            foreach (var t in DetermineInnerThresholds(thresholds.GetRange(range.Start, range.End - range.Start + 1), range.N))
+              yield return t;
+        }
+      }
+    }
+
+    private static void TrimBoundaryRanges(List<IndexRange> ranges) {
+      if (ranges.Count > 0)
+        if (ranges[0].Merge)
+          ranges.RemoveAt(0);
+        else
+          ranges[0].N--;
+      if (ranges.Count > 0)
+        if (ranges[ranges.Count - 1].Merge)
+          ranges.RemoveAt(ranges.Count - 1);
+        else
+          ranges[ranges.Count - 1].N--;
+    }
+
+    private static void RedistributeIndexes(List<IndexRange> ranges) {
+      IndexRange lastReceiver = null;
+      List<IndexRange> lastDistributors = new List<IndexRange>();
+      foreach (var range in ranges) {
+        if (range.Merge) {
+          range.AddReceiver(lastReceiver);
+          lastDistributors.Add(range);
+        } else {
+          foreach (var d in lastDistributors)
+            d.AddReceiver(range);
+          lastDistributors = new List<IndexRange>();
+          lastReceiver = range;
+        }
+      }
+      foreach (var range in ranges) {
+        range.Distribute();
+      }
+    }
+
+    private static List<IndexRange> CreateRanges(List<double> thresholds, List<int> indexes) {
+      var values = indexes.Select(i => new { i, v = thresholds[i] }).ToList();
+      var mergedRanges = values.GroupBy(iv => iv.v)
+        .Select(g => g.Count() == 1 ?
+          new IndexRange(g.First().i, g.First().i, 1, false) :
+          new IndexRange(g.Min(iv => iv.i), g.Max(iv => iv.i), g.Count(), true)).ToList();
+      IndexRange lastSpreadRange = null;
+      var ranges = new List<IndexRange>();
+      foreach (var group in mergedRanges) {
+        if (group.Merge) {
+          if (lastSpreadRange != null) {
+            ranges.Add(lastSpreadRange);
+            lastSpreadRange = null;
+          }
+          ranges.Add(group);
+        } else {
+          if (lastSpreadRange != null) {
+            lastSpreadRange.End = group.End;
+            lastSpreadRange.N++;
+          } else {
+            lastSpreadRange = group;
+          }
+        }
+      }
+      if (lastSpreadRange != null)
+        ranges.Add(lastSpreadRange);
+      return ranges;
+    }
+  }
+}
Index: /branches/2457_ExpertSystem/PerformanceComparison.sln
===================================================================
--- /branches/2457_ExpertSystem/PerformanceComparison.sln	(revision 16136)
+++ /branches/2457_ExpertSystem/PerformanceComparison.sln	(revision 16137)
@@ -29,4 +29,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Encodings.LinearLinkageEncoding-3.4", "HeuristicLab.Encodings.LinearLinkageEncoding\3.4\HeuristicLab.Encodings.LinearLinkageEncoding-3.4.csproj", "{BE698769-975A-429E-828C-72BB2B6182C8}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "UnitTests", "UnitTests\UnitTests.csproj", "{76241AF2-B428-4127-805D-667F79983F0F}"
 EndProject
 Global
@@ -196,7 +198,22 @@
 		{BE698769-975A-429E-828C-72BB2B6182C8}.Release|x86.ActiveCfg = Release|x86
 		{BE698769-975A-429E-828C-72BB2B6182C8}.Release|x86.Build.0 = Release|x86
+		{76241AF2-B428-4127-805D-667F79983F0F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Debug|x64.Build.0 = Debug|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Debug|x86.Build.0 = Debug|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Release|Any CPU.Build.0 = Release|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Release|x64.ActiveCfg = Release|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Release|x64.Build.0 = Release|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Release|x86.ActiveCfg = Release|Any CPU
+		{76241AF2-B428-4127-805D-667F79983F0F}.Release|x86.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
 		HideSolutionNode = FALSE
 	EndGlobalSection
+	GlobalSection(ExtensibilityGlobals) = postSolution
+		SolutionGuid = {C8E53BE4-B79D-431E-AFE7-03BB2062436C}
+	EndGlobalSection
 EndGlobal
Index: /branches/2457_ExpertSystem/UnitTests/InformationAnalysisTest.cs
===================================================================
--- /branches/2457_ExpertSystem/UnitTests/InformationAnalysisTest.cs	(revision 16137)
+++ /branches/2457_ExpertSystem/UnitTests/InformationAnalysisTest.cs	(revision 16137)
@@ -0,0 +1,27 @@
+﻿using HeuristicLab.Analysis.FitnessLandscape;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace UnitTests {
+  [TestClass]
+  public class InformationAnalysisTest {
+    [TestMethod]
+    public void TestFeatures() {
+      var qualities = new double[] { 1, 2, 1, 3, 2, 4, 2, 1, 1, 2, 4, 4, 3, 1 };
+      var ia = new InformationAnalysis(qualities);
+
+      Assert.AreEqual(0.8224, ia.InformationContent[0], 1e-04);
+      Assert.AreEqual(0.4603, ia.DensityBasinInformation[0], 1e-04);
+      Assert.AreEqual(0.6154, ia.PartialInformationContent[0], 1e-04);
+      Assert.AreEqual(0.9008, ia.TotalEntropy[0], 1e-04);
+      Assert.AreEqual(2, ia.InformationStability);
+      Assert.AreEqual(4, ia.Diversity);
+      Assert.AreEqual(5, ia.Regularity);
+      Assert.AreEqual(0.4603, ia.PeakDensityBasinInformation.Value, 1e-04);
+      Assert.AreEqual(0.8224, ia.PeakInformationContent.Value, 1e-04);
+      Assert.AreEqual(0.9008, ia.PeakTotalEntropy.Value, 1e-04);
+      Assert.AreEqual(0.7642, ia.SymmetricInformationContent[0], 1e-04);
+      Assert.AreEqual(0.2987, ia.SymmetricDensityBasinInformation[0], 1e-04);
+      Assert.AreEqual(0.7068, ia.SymmetricTotalEntropy[0], 1e-04);
+    }
+  }
+}
Index: /branches/2457_ExpertSystem/UnitTests/Properties/AssemblyInfo.cs
===================================================================
--- /branches/2457_ExpertSystem/UnitTests/Properties/AssemblyInfo.cs	(revision 16137)
+++ /branches/2457_ExpertSystem/UnitTests/Properties/AssemblyInfo.cs	(revision 16137)
@@ -0,0 +1,20 @@
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+[assembly: AssemblyTitle("UnitTests")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("UnitTests")]
+[assembly: AssemblyCopyright("Copyright Â©  2018")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+[assembly: ComVisible(false)]
+
+[assembly: Guid("76241af2-b428-4127-805d-667f79983f0f")]
+
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/2457_ExpertSystem/UnitTests/UnitTests.csproj
===================================================================
--- /branches/2457_ExpertSystem/UnitTests/UnitTests.csproj	(revision 16137)
+++ /branches/2457_ExpertSystem/UnitTests/UnitTests.csproj	(revision 16137)
@@ -0,0 +1,81 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="15.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.props" Condition="Exists('..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{76241AF2-B428-4127-805D-667F79983F0F}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>UnitTests</RootNamespace>
+    <AssemblyName>UnitTests</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <ProjectTypeGuids>{3AC096D0-A1C2-E12C-1390-A8335801FDAB};{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}</ProjectTypeGuids>
+    <VisualStudioVersion Condition="'$(VisualStudioVersion)' == ''">15.0</VisualStudioVersion>
+    <VSToolsPath Condition="'$(VSToolsPath)' == ''">$(MSBuildExtensionsPath32)\Microsoft\VisualStudio\v$(VisualStudioVersion)</VSToolsPath>
+    <ReferencePath>$(ProgramFiles)\Common Files\microsoft shared\VSTT\$(VisualStudioVersion)\UITestExtensionPackages</ReferencePath>
+    <IsCodedUITest>False</IsCodedUITest>
+    <TestProjectType>UnitTest</TestProjectType>
+    <NuGetPackageImportStamp>
+    </NuGetPackageImportStamp>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="Microsoft.VisualStudio.TestPlatform.TestFramework, Version=14.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+      <HintPath>..\packages\MSTest.TestFramework.1.2.0\lib\net45\Microsoft.VisualStudio.TestPlatform.TestFramework.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.VisualStudio.TestPlatform.TestFramework.Extensions, Version=14.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL">
+      <HintPath>..\packages\MSTest.TestFramework.1.2.0\lib\net45\Microsoft.VisualStudio.TestPlatform.TestFramework.Extensions.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="InformationAnalysisTest.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="packages.config" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Analysis.FitnessLandscape\3.3\HeuristicLab.Analysis.FitnessLandscape-3.3.csproj">
+      <Project>{5fbdcd4a-3c2a-4ec6-83ce-34b29f43621a}</Project>
+      <Name>HeuristicLab.Analysis.FitnessLandscape-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
+      <Project>{887425b4-4348-49ed-a457-b7d2c26ddbf9}</Project>
+      <Name>HeuristicLab.Analysis-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14ab8d24-25bc-400c-a846-4627aa945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(VSToolsPath)\TeamTest\Microsoft.TestTools.targets" Condition="Exists('$(VSToolsPath)\TeamTest\Microsoft.TestTools.targets')" />
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <Target Name="EnsureNuGetPackageBuildImports" BeforeTargets="PrepareForBuild">
+    <PropertyGroup>
+      <ErrorText>This project references NuGet package(s) that are missing on this computer. Use NuGet Package Restore to download them.  For more information, see http://go.microsoft.com/fwlink/?LinkID=322105. The missing file is {0}.</ErrorText>
+    </PropertyGroup>
+    <Error Condition="!Exists('..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.props')" Text="$([System.String]::Format('$(ErrorText)', '..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.props'))" />
+    <Error Condition="!Exists('..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.targets')" Text="$([System.String]::Format('$(ErrorText)', '..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.targets'))" />
+  </Target>
+  <Import Project="..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.targets" Condition="Exists('..\packages\MSTest.TestAdapter.1.2.0\build\net45\MSTest.TestAdapter.targets')" />
+</Project>
